<?php

/**
 * PrestaShop module created by VEKIA, a guy from official PrestaShop community ;-)
 *
 * @author    VEKIA https://www.prestashop.com/forums/user/132608-vekia/
 * @copyright 2010-2020 VEKIA
 * @license   This program is not free software and you can't resell and redistribute it
 *
 * CONTACT WITH DEVELOPER http://mypresta.eu
 * support@mypresta.eu
 */
class fbgroup extends Module
{
    public function __construct()
    {
        $this->name = 'fbgroup';
        $this->tab = 'advertising_marketing';
        $this->author = 'MyPresta.eu';
        $this->bootstrap = true;
        $this->version = '1.2.0';
        parent::__construct();
        $this->mypresta_link = 'https://mypresta.eu/modules/social-networks/facebook-join-to-group-widget.html';
        $this->displayName = $this->l('Facebook join to group widget');
        $this->description = $this->l('Module to display facebook "join group" widget');
        $this->checkforupdates();

        $this->modulehooks['top']['ps14'] = 1;
        $this->modulehooks['top']['ps15'] = 1;
        $this->modulehooks['top']['ps16'] = 1;
        $this->modulehooks['top']['ps17'] = 1;
        $this->modulehooks['displaytopColumn']['ps14'] = 0;
        $this->modulehooks['displaytopColumn']['ps15'] = 0;
        $this->modulehooks['displaytopColumn']['ps16'] = 1;
        $this->modulehooks['displaytopColumn']['ps17'] = 0;
        $this->modulehooks['displayNav']['ps14'] = 0;
        $this->modulehooks['displayNav']['ps15'] = 0;
        $this->modulehooks['displayNav']['ps16'] = 1;
        $this->modulehooks['displayNav']['ps17'] = 0;
        $this->modulehooks['displayNav1']['ps14'] = 0;
        $this->modulehooks['displayNav1']['ps15'] = 0;
        $this->modulehooks['displayNav1']['ps16'] = 0;
        $this->modulehooks['displayNav1']['ps17'] = 1;
        $this->modulehooks['displayNav2']['ps14'] = 0;
        $this->modulehooks['displayNav2']['ps15'] = 0;
        $this->modulehooks['displayNav2']['ps16'] = 0;
        $this->modulehooks['displayNav2']['ps17'] = 1;
        $this->modulehooks['leftcolumn']['ps14'] = 1;
        $this->modulehooks['leftcolumn']['ps15'] = 1;
        $this->modulehooks['leftcolumn']['ps16'] = 1;
        $this->modulehooks['leftcolumn']['ps17'] = 1;
        $this->modulehooks['rightcolumn']['ps14'] = 1;
        $this->modulehooks['rightcolumn']['ps15'] = 1;
        $this->modulehooks['rightcolumn']['ps16'] = 1;
        $this->modulehooks['rightcolumn']['ps17'] = 1;
        $this->modulehooks['fbgroup']['ps14'] = 1;
        $this->modulehooks['fbgroup']['ps15'] = 1;
        $this->modulehooks['fbgroup']['ps16'] = 1;
        $this->modulehooks['fbgroup']['ps17'] = 1;
        $this->modulehooks['footer']['ps14'] = 1;
        $this->modulehooks['footer']['ps15'] = 1;
        $this->modulehooks['footer']['ps16'] = 1;
        $this->modulehooks['footer']['ps17'] = 1;
        $this->modulehooks['home']['ps14'] = 1;
        $this->modulehooks['home']['ps15'] = 1;
        $this->modulehooks['home']['ps16'] = 1;
        $this->modulehooks['home']['ps17'] = 1;
    }

    public function checkforupdates($display_msg = 0, $form = 0)
    {
        // ---------- //
        // ---------- //
        // VERSION 16 //
        // ---------- //
        // ---------- //
        $this->mkey = "nlc";
        if (@file_exists('../modules/' . $this->name . '/key.php')) {
            @require_once('../modules/' . $this->name . '/key.php');
        } else {
            if (@file_exists(dirname(__FILE__) . $this->name . '/key.php')) {
                @require_once(dirname(__FILE__) . $this->name . '/key.php');
            } else {
                if (@file_exists('modules/' . $this->name . '/key.php')) {
                    @require_once('modules/' . $this->name . '/key.php');
                }
            }
        }
        if ($form == 1) {
            return '
            <div class="panel" id="fieldset_myprestaupdates" style="margin-top:20px;">
            ' . ($this->psversion() == 6 || $this->psversion() == 7 ? '<div class="panel-heading"><i class="icon-wrench"></i> ' . $this->l('MyPresta updates') . '</div>' : '') . '
			<div class="form-wrapper" style="padding:0px!important;">
            <div id="module_block_settings">
                    <fieldset id="fieldset_module_block_settings">
                         ' . ($this->psversion() == 5 ? '<legend style="">' . $this->l('MyPresta updates') . '</legend>' : '') . '
                        <form action="' . $_SERVER['REQUEST_URI'] . '" method="post">
                            <label>' . $this->l('Check updates') . '</label>
                            <div class="margin-form">' . (Tools::isSubmit('submit_settings_updates_now') ? ($this->inconsistency(0) ? '' : '') . $this->checkforupdates(1) : '') . '
                                <button style="margin: 0px; top: -3px; position: relative;" type="submit" name="submit_settings_updates_now" class="button btn btn-default" />
                                <i class="process-icon-update"></i>
                                ' . $this->l('Check now') . '
                                </button>
                            </div>
                            <label>' . $this->l('Updates notifications') . '</label>
                            <div class="margin-form">
                                <select name="mypresta_updates">
                                    <option value="-">' . $this->l('-- select --') . '</option>
                                    <option value="1" ' . ((int)(Configuration::get('mypresta_updates') == 1) ? 'selected="selected"' : '') . '>' . $this->l('Enable') . '</option>
                                    <option value="0" ' . ((int)(Configuration::get('mypresta_updates') == 0) ? 'selected="selected"' : '') . '>' . $this->l('Disable') . '</option>
                                </select>
                                <p class="clear">' . $this->l('Turn this option on if you want to check MyPresta.eu for module updates automatically. This option will display notification about new versions of this addon.') . '</p>
                            </div>
                            <label>' . $this->l('Module page') . '</label>
                            <div class="margin-form">
                                <a style="font-size:14px;" href="' . $this->mypresta_link . '" target="_blank">' . $this->displayName . '</a>
                                <p class="clear">' . $this->l('This is direct link to official addon page, where you can read about changes in the module (changelog)') . '</p>
                            </div>
                            <div class="panel-footer">
                                <button type="submit" name="submit_settings_updates"class="button btn btn-default pull-right" />
                                <i class="process-icon-save"></i>
                                ' . $this->l('Save') . '
                                </button>
                            </div>
                        </form>
                    </fieldset>
                    <style>
                    #fieldset_myprestaupdates {
                        display:block;clear:both;
                        float:inherit!important;
                    }
                    </style>
                </div>
            </div>
            </div>';
        } else {
            if (defined('_PS_ADMIN_DIR_')) {
                if (Tools::isSubmit('submit_settings_updates')) {
                    Configuration::updateValue('mypresta_updates', Tools::getValue('mypresta_updates'));
                }
                if (Configuration::get('mypresta_updates') != 0 || (bool)Configuration::get('mypresta_updates') != false) {
                    if (Configuration::get('update_' . $this->name) < (date("U") - 259200)) {
                        $actual_version = fbgroupUpdate::verify($this->name, (isset($this->mkey) ? $this->mkey : 'nokey'), $this->version);
                    }
                    if (fbgroupUpdate::version($this->version) < fbgroupUpdate::version(Configuration::get('updatev_' . $this->name)) && Tools::getValue('ajax', 'false') == 'false') {
                        $this->context->controller->warnings[] = '<strong>' . $this->displayName . '</strong>: ' . $this->l('New version available, check http://MyPresta.eu for more informations') . ' <a href="' . $this->mypresta_link . '">' . $this->l('More details in changelog') . '</a>';
                        $this->warning = $this->context->controller->warnings[0];
                    }
                } else {
                    if (Configuration::get('update_' . $this->name) < (date("U") - 259200)) {
                        $actual_version = fbgroupUpdate::verify($this->name, (isset($this->mkey) ? $this->mkey : 'nokey'), $this->version);
                    }
                }
                if ($display_msg == 1) {
                    if (fbgroupUpdate::version($this->version) < fbgroupUpdate::version(fbgroupUpdate::verify($this->name, (isset($this->mkey) ? $this->mkey : 'nokey'), $this->version))) {
                        return "<span style='color:red; font-weight:bold; font-size:16px; margin-right:10px;'>" . $this->l('New version available!') . "</span>";
                    } else {
                        return "<span style='color:green; font-weight:bold; font-size:16px; margin-right:10px;'>" . $this->l('Module is up to date!') . "</span>";
                    }
                }
            }
        }
    }

    public function inconsistency($ret)
    {
        return;
    }

    public function psversion($part = 1)
    {
        $version = _PS_VERSION_;
        $exp = $explode = explode(".", $version);
        if ($part == 1) {
            return $exp[1];
        }
        if ($part == 2) {
            return $exp[2];
        }
        if ($part == 3) {
            return $exp[3];
        }
    }

    public function installModuleHooks()
    {
        foreach ($this->modulehooks AS $modulehook => $value) {
            if (($this->psversion() == 4 && $value['ps14'] == 1) || ($this->psversion() == 5 && $value['ps15'] == 1) || ($this->psversion() == 6 && $value['ps16'] == 1) || ($this->psversion() == 7 && $value['ps17'] == 1)) {
                if ($this->registerHook($modulehook) == false) {
                    return false;
                }
            }
        }
        return true;
    }

    public function runSql($sql)
    {
        foreach ($sql as $s) {
            if (!Db::getInstance()->Execute($s)) {
                //return FALSE;
            }
        }
        return true;
    }

    public function install()
    {
        if (parent::install() == false || $this->installModuleHooks() == false || Configuration::updateValue('fbg_href', 'https://www.facebook.com/groups/prestashopstore/') == false || Configuration::updateValue('fbg_skin', 'light') == false || Configuration::updateValue('fbg_width', '280') == false || Configuration::updateValue('fbg_meta', false) == false || Configuration::updateValue('fbg_social', true) == false || Configuration::updateValue('fbg_app', false) == false || Configuration::updateValue('fbg_appid', '') == false || $this->registerHook('displayHeader') == false || $this->installdb() == false) {
            return false;
        }
        return true;
    }

    private function installdb()
    {
        return true;
    }

    public function hookHeader($params)
    {
        if (Configuration::get('fbg_app')) {
            $this->context->smarty->assign('fbg_appid', Configuration::get('fbg_appid'));
            return $this->display(__file__, 'views/displayHeader.tpl');
        }
    }

    public function adds()
    {
        return '<div style="diplay:block; clear:both; margin-bottom:20px;">
				<iframe src="//apps.facepages.eu/somestuff/whatsgoingon.html" width="100%" height="150" border="0" style="border:none;"></iframe>
			</div>';
    }

    public function getContent()
    {
        return $this->adds() . $this->displayForm() . $this->checkforupdates(0, 1);
    }

    public function displayForm()
    {
        $skin = array(
            array(
                'id_option' => 'light',
                'name' => $this->l('Light'),
            ),
            array(
                'id_option' => 'dark',
                'name' => $this->l('dark'),
            ),
        );

        $positions = array();
        foreach ($this->modulehooks AS $modulehook => $value) {
            if (($this->psversion() == 4 && $value['ps14'] == 1) || ($this->psversion() == 5 && $value['ps15'] == 1) || ($this->psversion() == 6 && $value['ps16'] == 1) || ($this->psversion() == 7 && $value['ps17'] == 1)) {
                $positions[] = array(
                    'id_option' => $modulehook,
                    'name' => $modulehook
                );
            }
        }


        $fields_form = array(
            'form' => array(
                'legend' => array(
                    'title' => $this->l('Facebook Join Group widget'),
                    'icon' => 'icon-cogs'
                ),
                'description' => $this->l('Settings of facebook "join group" module by MyPresta.eu'),
                'input' => array(
                    array(
                        'type' => 'text',
                        'label' => $this->l('Url to grup'),
                        'name' => 'fbg_href',
                        'desc' => $this->l('copy-paste here url to your facebook group'),
                    ),

                    array(
                        'type' => 'text',
                        'label' => $this->l('Width'),
                        'name' => 'fbg_width',
                        'prefix' => 'px',
                        'desc' => $this->l('Set the width of the join group box widget, put here number up to 500.'),
                    ),
                    array(
                        'type' => 'select',
                        'label' => $this->l('Where you want to display widget?'),
                        'name' => 'fbg_hook',
                        'desc' => $this->l('Select position of the widget, module will show it inside this hook'),
                        'options' => array(
                            'query' => $positions,
                            'id' => 'id_option',
                            'name' => 'name'
                        ),
                    ),
                    array(
                        'type' => 'select',
                        'label' => $this->l('Color'),
                        'name' => 'fbg_skin',
                        'desc' => $this->l('Set the colors of the "join group" widget'),
                        'options' => array(
                            'query' => $skin,
                            'id' => 'id_option',
                            'name' => 'name'
                        ),
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Include Meta'),
                        'name' => 'fbg_meta',
                        'desc' => $this->l('Shows other metadata about the group, e.g., Description.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => 1,
                                'label' => $this->l('On')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => 0,
                                'label' => $this->l('Off')
                            )
                        ),
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Include social context'),
                        'name' => 'fbg_social',
                        'desc' => $this->l('Show the number of friends who are members of the group.'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => 1,
                                'label' => $this->l('On')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => 0,
                                'label' => $this->l('Off')
                            )
                        ),
                    ),
                    array(
                        'type' => 'switch',
                        'label' => $this->l('Include APP'),
                        'name' => 'fbg_app',
                        'desc' => $this->l('Facebook Application all.js is a special script required for facebook widgets. If your shop already have it - you do not have to add it one more time - it is for better performance purposes'),
                        'values' => array(
                            array(
                                'id' => 'active_on',
                                'value' => 1,
                                'label' => $this->l('On')
                            ),
                            array(
                                'id' => 'active_off',
                                'value' => 0,
                                'label' => $this->l('Off')
                            )
                        ),
                    ),
                    array(
                        'type' => 'text',
                        'label' => $this->l('APP ID'),
                        'name' => 'fbg_appid',
                        'desc' => '<a href="https://mypresta.eu/en/art/basic-tutorials/how-to-create-facebook-application-id.html" target="_blank">' . $this->l('read how to create own app id') . '</a>',
                    ),
                ),
                'submit' => array(
                    'title' => $this->l('Save settings'),
                ),
            )
        );


        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->table = $this->table;
        $lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
        $helper->default_form_language = $lang->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
        $this->fields_form = array();
        $helper->identifier = 'displayFormIdentifier';
        $helper->submit_action = 'submitdisplayForm';
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false) . '&configure=' . $this->name . '&tab_module=' . $this->tab . '&module_name=' . $this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars = array(
            'fields_value' => $this->getConfigFieldsValues(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id
        );
        return $helper->generateForm(array($fields_form));
    }

    public function getConfigFieldsValues()
    {
        if (Tools::isSubmit('submitdisplayForm')) {
            Configuration::updateValue('fbg_href', Tools::getValue('fbg_href'));
            Configuration::updateValue('fbg_skin', Tools::getValue('fbg_skin'));
            Configuration::updateValue('fbg_width', Tools::getValue('fbg_width'));
            Configuration::updateValue('fbg_meta', Tools::getValue('fbg_meta'));
            Configuration::updateValue('fbg_social', Tools::getValue('fbg_social'));
            Configuration::updateValue('fbg_appid', Tools::getValue('fbg_appid'));
            Configuration::updateValue('fbg_app', Tools::getValue('fbg_app'));
            Configuration::updateValue('fbg_hook', Tools::getValue('fbg_hook'));
        }

        return array(
            'fbg_href' => Configuration::get('fbg_href'),
            'fbg_skin' => Configuration::get('fbg_skin'),
            'fbg_width' => Configuration::get('fbg_width'),
            'fbg_meta' => Configuration::get('fbg_meta'),
            'fbg_social' => Configuration::get('fbg_social'),
            'fbg_app' => Configuration::get('fbg_app'),
            'fbg_appid' => Configuration::get('fbg_appid'),
            'fbg_hook' => Configuration::get('fbg_hook'),
        );
    }


    public function hookTop()
    {
        if (Configuration::get('fbg_hook') == 'top')
            return $this->showWidget('Top');
    }

    public function hookdisplayTopColumn()
    {
        if (Configuration::get('fbg_hook') == 'displaytopColumn')
            return $this->showWidget('displaytopColumn');
    }

    public function hookdisplayNav()
    {
        if (Configuration::get('fbg_hook') == 'displayNav')
            return $this->showWidget('displayNav');
    }

    public function hookdisplayNav1()
    {
        if (Configuration::get('fbg_hook') == 'displayNav1')
            return $this->showWidget('Nav1');
    }

    public function hookdisplayNav2()
    {
        if (Configuration::get('fbg_hook') == 'displayNav2')
            return $this->showWidget('displayNav2');
    }

    public function hookdisplayLeftColumn()
    {
        if (Configuration::get('fbg_hook') == 'leftcolumn')
            return $this->showWidget('leftColumn');
    }

    public function hookdisplayRightColumn()
    {
        if (Configuration::get('fbg_hook') == 'rightcolumn')
            return $this->showWidget('rightColumn');
    }

    public function hookfbgroup()
    {
        if (Configuration::get('fbg_hook') == 'fbgroup')
            return $this->showWidget('fbgroup');
    }

    public function hookfooter()
    {
        if (Configuration::get('fbg_hook') == 'footer')
            return $this->showWidget('footer');
    }

    public function hookhome()
    {
        if (Configuration::get('fbg_hook') == 'home')
            return $this->showWidget('home');
    }

    public function showWidget($position = 'default')
    {
        $this->context->smarty->assign('fbg_position', $position);
        $this->context->smarty->assign('fbg_href', Configuration::get('fbg_href'));
        $this->context->smarty->assign('fbg_width', Configuration::get('fbg_width'));
        $this->context->smarty->assign('fbg_meta', Configuration::get('fbg_meta'));
        $this->context->smarty->assign('fbg_social', Configuration::get('fbg_social'));
        return $this->display(__file__, 'views/displayWidget.tpl');

    }
}

class fbgroupUpdate extends fbgroup
{
    public static function version($version)
    {
        $version = (int)str_replace(".", "", $version);
        if (strlen($version) == 3) {
            $version = (int)$version . "0";
        }
        if (strlen($version) == 2) {
            $version = (int)$version . "00";
        }
        if (strlen($version) == 1) {
            $version = (int)$version . "000";
        }
        if (strlen($version) == 0) {
            $version = (int)$version . "0000";
        }
        return (int)$version;
    }

    public static function encrypt($string)
    {
        return base64_encode($string);
    }

    public static function verify($module, $key, $version)
    {
        if (ini_get("allow_url_fopen")) {
            if (function_exists("file_get_contents")) {
                $actual_version = @file_get_contents('http://dev.mypresta.eu/update/get.php?module=' . $module . "&version=" . self::encrypt($version) . "&lic=$key&u=" . self::encrypt(_PS_BASE_URL_ . __PS_BASE_URI__));
            }
        }
        Configuration::updateValue("update_" . $module, date("U"));
        Configuration::updateValue("updatev_" . $module, $actual_version);
        return $actual_version;
    }
}


?>